Unit DE00RS_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE00RD_p, DE04RM_p;

procedure DE00RS(F :Proc_F_DE; M :Integer; X :Real; var Y :Array of Real;
                H :Real; var A :Array of Real; var E :Array of Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real);
implementation

procedure DE00RS(F :Proc_F_DE; M :Integer; X :Real; var Y :Array of Real;
                H :Real; var A :Array of Real; var E :Array of Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real);
var
I :Integer;
C1,C2 :Real;
const
SYS037 :Real = 0.333333333333;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100;
begin
C1  := H/2.;
C2  := C1*SYS037;
F(X,Y,R,M);
DE00RD(M,R,Y,A);
DE04RM(M,E,Y,R1);
for I:=1 to M do
 begin
  R[I-1] := C1*R[I-1];
_10:
 end;
DE04RM(M,E,R,R2);
for I:=1 to M do
 begin
  R[I-1] := R1[I-1] + R2[I-1];
_20:
 end;
F(X + C1,R,R3,M);
DE00RD(M,R3,R,A);
for I:=1 to M do
 begin
  R3[I-1] := R3[I-1]*H;
_30:
 end;
for I:=1 to M do
 begin
  R[I-1] := R1[I-1] + R3[I-1]/2.;
_40:
 end;
for I:=1 to M do
 begin
  R2[I-1] := R2[I-1] + R3[I-1];
_50:
 end;
F(X + C1,R,R3,M);
DE00RD(M,R3,R,A);
for I:=1 to M do
 begin
  R3[I-1] := R3[I-1]*H;
_60:
 end;
for I:=1 to M do
 begin
  R[I-1] := R1[I-1] + R3[I-1];
_70:
 end;
for I:=1 to M do
 begin
  R2[I-1] := R2[I-1] + R3[I-1];
_80:
 end;
DE04RM(M,E,R,R3);
F(X + H,R3,R,M);
DE00RD(M,R,R3,A);
for I:=1 to M do
 begin
  R1[I-1] := R1[I-1] + R2[I-1]*SYS037;
_90:
 end;
DE04RM(M,E,R1,R2);
for I:=1 to M do
 begin
  R[I-1] := R2[I-1] + C2*R[I-1];
_100:
 end;
end;

end.
